/*
 *  soapUI, copyright (C) 2004-2007 eviware.com 
 *
 *  soapUI is free software; you can redistribute it and/or modify it under the 
 *  terms of version 2.1 of the GNU Lesser General Public License as published by 
 *  the Free Software Foundation.
 *
 *  soapUI is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without 
 *  even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 *  See the GNU Lesser General Public License for more details at gnu.org.
 */

package com.eviware.soapui.model.testsuite;

import com.eviware.soapui.impl.wsdl.teststeps.WsdlMessageAssertion;
import com.eviware.soapui.model.ModelItem;
import com.eviware.soapui.model.testsuite.Assertable.AssertionStatus;

public interface TestAssertion extends ModelItem
{
	public final static String DISABLED_PROPERTY = WsdlMessageAssertion.class.getName() + "@disabled";
	public final static String STATUS_PROPERTY = WsdlMessageAssertion.class.getName() + "@status";
	public final static String ERRORS_PROPERTY = WsdlMessageAssertion.class.getName() + "@errors";
	public final static String CONFIGURATION_PROPERTY = WsdlMessageAssertion.class.getName() + "@configuration";

	public AssertionStatus getStatus();

	public AssertionError[] getErrors();

	public boolean isAllowMultiple();

	public boolean isConfigurable();

	public boolean isClonable();

	public boolean configure();

	public Assertable getAssertable();

	public String getLabel();

	public boolean isDisabled();
}

